import sys
import matplotlib.pyplot as plt
__author__ = 'jenda'


with open(sys.argv[1],"r") as f:
    n = int(f.readline().split()[0])
    x = [0]*n
    y = [0]*n
    for i in range(n):
        x[i], y[i] = [int(j) for j in f.readline().split()]

# Construct Graph
G = {}
beta = 1/2000.0
for i in range(n):
    for j in range(i+1, n):
        suma = 0.0
        for k in range(i+1, j):
            if not (x[i]==x[j] and y[i]==y[j]):
                suma += (((y[j]-y[i])*x[k] - (x[j]-x[i])*y[k] + x[j]*y[i] - y[j]*x[i])**2)/((y[j]-y[i])**2 + (x[j]-x[i])**2)
            else:
                suma += (x[i] - x[k])**2 + (y[i] - y[k])**2
        G[i, j] = 1.0 + beta*suma


# bellman-ford
l = [100000]*n
l[0] = 0
p = [100000]*n
for k in range(n-1):
    for (v, w) in G.keys():
        if l[w] > l[v] + G[v, w]:
            l[w] = l[v] + G[v, w]
            p[w] = v

v = n - 1
path = []
while v != 0:
    path.append(v)
    v = p[v]
path.append(0)

x_new = [x[i] for i in reversed(path)]
y_new = [y[i] for i in reversed(path)]
plt.plot(x,y)
plt.plot(x_new,y_new, 'r--')
plt.show()
#print("shortest s-t distance Bellman-Ford:", l[4])